package com.fp.persistence.pgeneral.acco;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENEACCOUNTSEQUENCE*/
@Embeddable
public class TgeneAccountSequenceKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="MODULECODE", nullable=false,updatable=false)

/**
* Codigo de modulo
*/
private String modulecode;

@Column(name="ACCOUNTSEQUENCE", nullable=false,updatable=false)

/**
* Secuencia
*/
private String accountsequence;

/**Contructor por defecto*/
public TgeneAccountSequenceKey(){}
/**Contructor de TgeneAccountSequenceKey
@param pModulecode Codigo de modulo
@param pAccountsequence Secuencia
*/
public TgeneAccountSequenceKey(String pModulecode,String pAccountsequence){
 modulecode=pModulecode;
 accountsequence=pAccountsequence;
}
/**Obtiene el valor de modulecode
@return valor de modulecode*/
public String getModulecode(){
  return modulecode;
}
/**Fija el valor de modulecode
@param pModulecode nuevo Valor de modulecode*/
public void setModulecode(String pModulecode){
  modulecode=pModulecode;
}

/**Obtiene el valor de accountsequence
@return valor de accountsequence*/
public String getAccountsequence(){
  return accountsequence;
}
/**Fija el valor de accountsequence
@param pAccountsequence nuevo Valor de accountsequence*/
public void setAccountsequence(String pAccountsequence){
  accountsequence=pAccountsequence;
}

/**Implementación de la comparación de TgeneAccountSequenceKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneAccountSequenceKey))return false;
  TgeneAccountSequenceKey that = (TgeneAccountSequenceKey) o;
  if (this.getModulecode() == null || that.getModulecode() == null){
      return false;
  }
  if (! this.getModulecode().equals(that.getModulecode())){
    return false;
  }
  if (this.getAccountsequence() == null || that.getAccountsequence() == null){
      return false;
  }
  if (! this.getAccountsequence().equals(that.getAccountsequence())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneAccountSequenceKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getModulecode() == null ? 0 : this.getModulecode().hashCode());
    result = result * 37 + (this.getAccountsequence() == null ? 0 : this.getAccountsequence().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
